Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.tools.ant.taskdefs
Class Move

    java.lang.Object
      org.apache.tools.ant.ProjectComponent
          org.apache.tools.ant.Task
              org.apache.tools.ant.taskdefs.Copy
                  org.apache.tools.ant.taskdefs.Move

All Implemented Interfaces:
  java.lang.Cloneable

    public class Move

extends Copy

Moves a file or directory to a new file or directory. By default, the destination file is overwritten if it already exists. When overwrite is turned off, then files are only moved if the source file is newer than the destination file, or when the destination file does not exist.

Source files and directories are only deleted when the file or directory has been copied to the destination successfully. Filtering also works.

This implementation is based on Arnout Kuiper's initial design document, the following mailing list discussions, and the copyfile/copydir tasks.

Since:
  Ant 1.2

Field Summary

Fields inherited from class org.apache.tools.ant.taskdefs.Copy
`completeDirMap, destDir, destFile, dirCopyMap, failonerror, file, fileCopyMap, filesets, fileUtils, filtering, flatten, forceOverwrite, includeEmpty, mapperElement, preserveLastModified, rcs, verbosity`

Fields inherited from class org.apache.tools.ant.Task
`target, taskName, taskType, wrapper`

Fields inherited from class org.apache.tools.ant.ProjectComponent
`description, location, project`

Constructor Summary
`Move()` Constructor of object.

Method Summary
`protected void` | `deleteDir(java.io.File d)` Go and delete the directory tree.
`protected void` | `deleteDir(java.io.File d, boolean deleteFiles)` Go and delete the directory tree.
`protected void` | `doFileOperations()` Override copy's doFileOperations to move the files instead of copying them.
`protected boolean` | `okToDelete(java.io.File d)` Its only ok to delete a directory tree if there are no files in it.
`protected boolean` | `renameFile(java.io.File sourceFile, java.io.File destFile, boolean filtering, boolean overwrite)` Attempts to rename a file from a source to a destination.
`void` | `setPerformGcOnFailedDelete(boolean b)` Whether to perform a garbage collection before retrying a failed delete.
`protected void` | `validateAttributes()` Ensure we have a consistent and legal set of attributes, and set any internal flags necessary based on different combinations of attributes.

Methods inherited from class org.apache.tools.ant.taskdefs.Copy
`add, add, addFileset, buildMap, buildMap, createFilterChain, createFilterSet, createMapper, doResourceOperations, execute, getEncoding, getFileUtils, getFilterChains, getFilterSets, getForce, getOutputEncoding, getPreserveLastModified, isEnableMultipleMapping, scan, scan, setEnableMultipleMappings, setEncoding, setFailOnError, setFile, setFiltering, setFlatten, setForce, setGranularity, setIncludeEmptyDirs, setOutputEncoding, setOverwrite, setPreserveLastModified, setPreserveLastModified, setQuiet, setTodir, setTofile, setVerbose, supportsNonFileResources`

Methods inherited from class org.apache.tools.ant.Task
`bindToOwner, getOwningTarget, getRuntimeConfigurableWrapper, getTaskName, getTaskType, getWrapper, handleErrorFlush, handleErrorOutput, handleFlush, handleInput, handleOutput, init, isInvalid, log, log, log, log, maybeConfigure, perform, reconfigure, setOwningTarget, setRuntimeConfigurableWrapper, setTaskName, setTaskType`

Methods inherited from class org.apache.tools.ant.ProjectComponent
`clone, getDescription, getLocation, getProject, setDescription, setLocation, setProject`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Move

    public Move()

  Constructor of object. This sets the forceOverwrite attribute of the Copy parent class to true.

Method Detail

### setPerformGcOnFailedDelete

    public void setPerformGcOnFailedDelete(boolean b)

  Whether to perform a garbage collection before retrying a failed delete.

  This may be required on Windows (where it is set to true by default) but also on other operating systems, for example when deleting directories from an NFS share.

  Since:
    Ant 1.8.3

### validateAttributes

    protected void validateAttributes()
                               throws BuildException

  Ensure we have a consistent and legal set of attributes, and set any internal flags necessary based on different combinations of attributes..

  Overrides:
    `validateAttributes` in class `Copy`
  Throws:
    `BuildException` - if an error occurs.

### doFileOperations

    protected void doFileOperations()

  Override copy's doFileOperations to move the files instead of copying them.

  Overrides:
    `doFileOperations` in class `Copy`

### okToDelete

    protected boolean okToDelete(java.io.File d)

  Its only ok to delete a directory tree if there are no files in it.

  Parameters:
    `d` - the directory to check
  Returns:
    true if a deletion can go ahead

### deleteDir

    protected void deleteDir(java.io.File d)

  Go and delete the directory tree.

  Parameters:
    `d` - the directory to delete

### deleteDir

    protected void deleteDir(java.io.File d,
                             boolean deleteFiles)

  Go and delete the directory tree.

  Parameters:
    `d` - the directory to delete
    `deleteFiles` - whether to delete files

### renameFile

    protected boolean renameFile(java.io.File sourceFile,
                                 java.io.File destFile,
                                 boolean filtering,
                                 boolean overwrite)
                          throws java.io.IOException,
                                 BuildException

  Attempts to rename a file from a source to a destination. If overwrite is set to true, this method overwrites existing file even if the destination file is newer. Otherwise, the source file is renamed only if the destination file is older than it. Method then checks if token filtering is used. If it is, this method returns false assuming it is the responsibility to the copyFile method.

  Parameters:
    `sourceFile` - the file to rename
    `destFile` - the destination file
    `filtering` - if true, filtering is in operation, file will be copied/deleted instead of renamed
    `overwrite` - if true force overwrite even if destination file is newer than source file
  Returns:
    true if the file was renamed
  Throws:
    `java.io.IOException` - if an error occurs
    `BuildException` - if an error occurs

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD